#include <iostream>
#include <gtest/gtest.h>
#include "rectangle.h"

// double calculateArea(double l, double w);
// double calculatePerimeter(double l, double w);
// double aspectRatio(double length, double width);

int main() {
    double length, width, increment;

    std::cout << "Enter length and width of the rectangle: ";
    std::cin >> length >> width;

    std::cout << "Enter increment for sides: ";
    std::cin >> increment;

    // Створення об'єкта класу CRectangle з введеними користувачем параметрами
    CRectangle rectangle(length, width);
    CRectangle rectangle2(3, 4);
    CRectangle rectangle3(5, 5);

    // Виведення кількості створених об'єктів
    std::cout << "Number of created objects: " << CRectangle::getCount() << std::endl << std::endl;

    // Виведення площі та периметру прямокутника
    std::cout << "Area: " << rectangle.calculateArea() << std::endl;
    std::cout << "Perimeter: " << rectangle.calculatePerimeter() << std::endl << std::endl;

   // std::cout << "Area (overloaded): " << calculateArea(length, width) << std::endl;
    //std::cout << "Perimeter (overloaded): " << calculatePerimeter(length, width) << std::endl;

    // Виведення співвідношня сторін
    std::cout << "Aspect Ratio: " << rectangle.aspectRatio() << std::endl;

  //  std::cout << "Aspect Ratio (overloaded): " << aspectRatio(length, width) << std::endl;
//
    // Виведення довжин сторін прямокутника до та після обертання
    std::cout << "Length before rotation: " << rectangle.getLength() << std::endl;
    std::cout << "Width before rotation: " << rectangle.getWidth() << std::endl;

    // Обертання прямокутника
    rectangle.rotate();

    // Виведення довжин сторін прямокутника після обертання
    std::cout << "Length after rotation: " << rectangle.getLength() << std::endl;
    std::cout << "Width after rotation: " << rectangle.getWidth() << std::endl;

    // Обертання прямокутника
    !rectangle;

    // Виведення довжин сторін прямокутника після обертання
    std::cout << "Length after rotation: " << rectangle.getLength() << std::endl;
    std::cout << "Width after rotation: " << rectangle.getWidth() << std::endl;

    // Збільшення всіх сторін на введений користувачем інкремент та виведення їх нових значень
    rectangle + increment;
    std::cout << "Length after increase: " << rectangle.getLength() << std::endl;
    std::cout << "Width after increase: " << rectangle.getWidth() << std::endl;

    // Виведення вимірів другого прямокутника
    std::cout << "Dimensions of the second rectangle:" << std::endl;
    std::cout << "Length: " << rectangle2.getLength() << std::endl;
    std::cout << "Width: " << rectangle2.getWidth() << std::endl;

    // Виведення вимірів третього прямокутника
    std::cout << "Dimensions of the third rectangle:" << std::endl;
    std::cout << "Length: " << rectangle3.getLength() << std::endl;
    std::cout << "Width: " << rectangle3.getWidth() << std::endl;

    std::cout << "rectangle2 == rectangle3: " << (rectangle2 == rectangle3) << std::endl;
    std::cout << "rectangle2 != rectangle3: " << (rectangle2 != rectangle3) << std::endl;

    // Введення та виведення прямокутника за допомогою перевантажених операторів
    CRectangle rectangle4;
    std::cout << "Enter length and width of the rectangle (using overloaded operator>>): ";
    std::cin >> rectangle4;
    std::cout << "Rectangle details (using overloaded operator<<): " << rectangle4 << std::endl;

    ::testing::InitGoogleTest();

    int testResult = RUN_ALL_TESTS();

    if (testResult == 0) {
        std::cout << "All tests passed successfully!" << std::endl;
    } else {
        std::cerr << "Tests failed with error code: " << testResult << std::endl;
    }

    return 0;
}
